execute as @e[type=minecraft:armor_stand,name="hwld:wand"] at @s run execute as @e[type=minecraft:armor_stand,name="hwld:centre",limit=1,sort=nearest,distance=..4,scores={hwd-anim_dir=-2}] at @s run execute as @e[tag=hwld] if score @s hwd = @e[type=minecraft:armor_stand,name="hwld:centre",sort=nearest,limit=1] hwd run scoreboard players set @s hwd-anim_dir 1
execute as @e[type=minecraft:armor_stand,name="hwld:wand"] at @s run execute as @e[type=minecraft:armor_stand,name="hwld:centre",limit=1,sort=nearest,distance=..4,scores={hwd-anim_dir=2}] at @s run execute as @e[tag=hwld] if score @s hwd = @e[type=minecraft:armor_stand,name="hwld:centre",sort=nearest,limit=1] hwd run scoreboard players set @s hwd-anim_dir -1
execute at @e[type=minecraft:armor_stand,name="hwld:wand"] run execute at @p[gamemode=survival,distance=..5] run summon minecraft:item ~ ~ ~ {Item:{id:"minecraft:armor_stand",Count:1b,tag:{display:{Name:"{\"text\":\"magic wand\"}"},EntityTag:{CustomName:"{\"text\":\"hwld:wand\"}",Marker:1b,Invisible:1b},CustomModelData:100}}}
kill @e[type=minecraft:armor_stand,name="hwld:wand"]

scoreboard players add @e[scores={hwd-anim_dir=-1}] hwd-animation 1
scoreboard players remove @e[scores={hwd-anim_dir=1}] hwd-animation 1
scoreboard players set @e[scores={hwd-anim_dir=1,hwd-animation=-1}] hwd-anim_dir 2
scoreboard players set @e[scores={hwd-anim_dir=-1,hwd-animation=550}] hwd-anim_dir -2

# ensure the centre armour stand is facing the horizon
execute as @e[type=minecraft:armor_stand,name="hwld:centre"] at @s run tp @s ~ ~ ~ ~ 0

# hinges
execute at @e[type=minecraft:armor_stand,name="hwld:centre",scores={hwd-animation=0}] run execute as @e[type=minecraft:armor_stand,tag=hwld-hinge] if score @s hwd = @e[type=minecraft:armor_stand,name="hwld:centre",sort=nearest,limit=1] hwd run tp @s ~ ~ ~ ~ ~
execute at @e[type=minecraft:armor_stand,name="hwld:centre",scores={hwd-animation=90}] run execute as @e[type=minecraft:armor_stand,tag=hwld-hinge] if score @s hwd = @e[type=minecraft:armor_stand,name="hwld:centre",sort=nearest,limit=1] hwd run tp @s ~ ~ ~ ~ ~
execute as @e[type=minecraft:armor_stand,name="hwld:left_hinge",scores={hwd-animation=0}] at @s run tp @s ^2.99 ^ ^ ~90 ~
execute as @e[type=minecraft:armor_stand,name="hwld:right_hinge",scores={hwd-animation=0}] at @s run tp @s ^-2.99 ^ ^ ~-90 ~
execute as @e[type=minecraft:armor_stand,name="hwld:left_hinge",scores={hwd-animation=90}] at @s run tp @s ^2.99 ^ ^ ~ ~
execute as @e[type=minecraft:armor_stand,name="hwld:right_hinge",scores={hwd-animation=90}] at @s run tp @s ^-2.99 ^ ^ ~ ~

# hinge animation logic
execute as @e[type=minecraft:armor_stand,name="hwld:left_hinge",scores={hwd-animation=1..89,hwd-anim_dir=-1}] at @s run tp @s ~ ~ ~ ~-1 ~
execute as @e[type=minecraft:armor_stand,name="hwld:right_hinge",scores={hwd-animation=1..89,hwd-anim_dir=-1}] at @s run tp @s ~ ~ ~ ~1 ~
execute as @e[type=minecraft:armor_stand,name="hwld:left_hinge",scores={hwd-animation=1..89,hwd-anim_dir=1}] at @s run tp @s ~ ~ ~ ~1 ~
execute as @e[type=minecraft:armor_stand,name="hwld:right_hinge",scores={hwd-animation=1..89,hwd-anim_dir=1}] at @s run tp @s ~ ~ ~ ~-1 ~

# doors
execute as @e[scores={hwd-animation=0..99}] run function hwd:large_door/door_swing_offset

# bar animation
execute as @e[name="hwld:bar"] run scoreboard players operation @s hwd-bar_anim = @s hwd-animation
execute as @e[name="hwld:bar"] run scoreboard players operation @s hwd-bar_anim -= @s hwd-bar-offset

execute as @e[type=minecraft:armor_stand,scores={hwd-bar_anim=0..59}] run function hwd:large_door/bar_animation

execute as @e[type=minecraft:armor_stand,name="hwld:bar",tag=!hwld-bar_lock,scores={hwd-bar_anim=21..59}] run data modify entity @s Pose.Head[0] set from entity @s Rotation[1]
execute as @e[type=minecraft:armor_stand,name="hwld:bar",tag=!hwld-bar_lock,scores={hwd-bar_anim=20}] run data modify entity @s Pose.Head[0] set value 0.1f

# audio
execute as @e[type=minecraft:armor_stand,scores={hwd-bar_anim=59,hwd-anim_dir=-1},limit=1] at @s run playsound minecraft:hwd.clunk master @a ~ ~ ~ 1 1 0.3
execute as @e[type=minecraft:armor_stand,scores={hwd-bar_anim=20,hwd-anim_dir=1},limit=1] at @s run playsound minecraft:hwd.clunk master @a ~ ~ ~ 0.5 1 0.3
execute as @e[type=minecraft:armor_stand,scores={hwd-bar_anim=25,hwd-anim_dir=-1},limit=1] at @s run playsound minecraft:hwd.scrape master @a ~ ~ ~ 0.2 1 0.1
execute as @e[type=minecraft:armor_stand,scores={hwd-bar_anim=59,hwd-anim_dir=1},limit=1] at @s run playsound minecraft:hwd.scrape master @a ~ ~ ~ 0.2 1 0.1
execute as @e[type=minecraft:armor_stand,scores={hwd-animation=0,hwd-anim_dir=-1},limit=1] at @s run playsound minecraft:hwd.creek master @a ~ ~ ~ 0.2 1 0.1
execute as @e[type=minecraft:armor_stand,scores={hwd-animation=90,hwd-anim_dir=-1},limit=1] at @s run playsound minecraft:hwd.slam master @a ~ ~ ~ 1 1 0.3
execute as @e[type=minecraft:armor_stand,scores={hwd-animation=80,hwd-anim_dir=1},limit=1] at @s run playsound minecraft:hwd.creek master @a ~ ~ ~ 0.2 1 0.1
